--------------------------------------------------------------------------------
-- Dropdownmenu                                                               --
--------------------------------------------------------------------------------
local _, me = ...                                 --Includes all functions and variables

function me:UpdateMenu(level, value)
  local info = {}
  if not level then return end
  --<<LEVEL 1>>--
  if level == 1 then
   me.dewdrop:AddLine('text',"|cff00ff00"..me.L["primary"].."|r",'isTitle',true,function() return end)
   for k,v in me:pairsByKeys(me:FilterProfs(me.P.Primary)) do
    if (v.secure == true) then
     me.dewdrop:AddLine('text',k,'icon',v.icon,'disabled',v.disabled,'secure',{type = "spell",spell = k},'tooltipFunc',function() return end,'closeWhenClicked',true)
    else
     me.dewdrop:AddLine('text',k,'icon',v.icon,'disabled',v.disabled,'func',function() CastSpellByName(k) end,'tooltipFunc',function() return end,'closeWhenClicked',true)
    end
    if (v["more"]~=nil) then
     for kk,vv in me:pairsByKeys(v["more"]) do
      if (vv.secure == true) then
       me.dewdrop:AddLine('text',kk,'icon',vv.icon,'disabled',vv.disabled,'secure',{type = "spell",spell = kk},'tooltipFunc',function() return end,'closeWhenClicked',true)
      else
       me.dewdrop:AddLine('text',kk,'icon',vv.icon,'disabled',vv.disabled,'func',function() CastSpellByName(kk) end,'tooltipFunc',function() return end,'closeWhenClicked',true)
      end
     end
    end
   end
   me.dewdrop:AddLine()
   me.dewdrop:AddLine('text',"|cff00ff00"..me.L["secondary"].."|r",'isTitle',true,function() return end)
   for k,v in me:pairsByKeys(me:FilterProfs(me.P.Secondary)) do
    if (v.secure == true) then
     me.dewdrop:AddLine('text',k,'icon',v.icon,'disabled',v.disabled,'secure',{type = "spell",spell = k},'tooltipFunc',function() return end,'closeWhenClicked',true)
    else
     me.dewdrop:AddLine('text',k,'icon',v.icon,'disabled',v.disabled,'func',function() CastSpellByName(k) end,'tooltipFunc',function() return end,'closeWhenClicked',true)
    end
    if (v["more"]~=nil) then
     for kk,vv in me:pairsByKeys(v["more"]) do
      if (vv.secure == true) then
       me.dewdrop:AddLine('text',kk,'icon',vv.icon,'disabled',vv.disabled,'secure',{type = "spell",spell = kk},'tooltipFunc',function() return end,'closeWhenClicked',true)
      else
       me.dewdrop:AddLine('text',kk,'icon',vv.icon,'disabled',vv.disabled,'func',function() CastSpellByName(kk) end,'tooltipFunc',function() return end,'closeWhenClicked',true)
      end
     end
    end
   end
   me.dewdrop:AddLine()                           --list other chars
   me.dewdrop:AddLine('hasArrow',true,'text',"|cff00ff00"..me.L["otherchar"].."|r",'value',"tradelinks",'tooltipFunc',function() return end)
   me.dewdrop:AddLine()
   me.dewdrop:AddLine('hasArrow',true,'text',me.L["settings"],'value',"config",'tooltipFunc',function() return end)
  --<<LEVEL 2>>--
  elseif level == 2 then
   --Settingsmenu
   if value == "config" then
    me.dewdrop:AddLine('hasArrow',true,'text',me.L["defaultprofession"],'value',"default",'tooltipFunc',function() return end)
    me.dewdrop:AddLine('hasArrow',true,'text',me.L["launcher"],'value',"launcher",'tooltipFunc',function() return end)
    me.dewdrop:AddLine()
    if (me.save.config.showprimary == true) then info.checked = true else info.checked = nil end
    info.func = function()
     if (me.save.config.showprimary == true) then
      me.save.config.showprimary = false
     else
      me.save.config.showprimary = true
     end
    end
    me.dewdrop:AddLine('text',me.L["showprimary"],'func',info.func,'checked',info.checked,'tooltipFunc',function() return end)
    if (me.save.config.showsecondary == true) then info.checked = true else info.checked = nil end
    info.func = function()
     if (me.save.config.showsecondary == true) then
      me.save.config.showsecondary = false
     else
      me.save.config.showsecondary = true
     end
    end
    me.dewdrop:AddLine('text',me.L["showsecondary"],'func',info.func,'checked',info.checked,'tooltipFunc',function() return end)
    if (me.save.config.showcds == true) then info.checked = true else info.checked = nil end
    info.func = function()
     if (me.save.config.showcds == true) then
      me.save.config.showcds = false
     else
      me.save.config.showcds = true
     end
    end
    me.dewdrop:AddLine('text',me.L["showcds"],'func',info.func,'checked',info.checked,'tooltipFunc',function() return end)
    if (me.save.config.showother == true) then info.checked = true else info.checked = nil end
    info.func = function()
     if (me.save.config.showother == true) then
      me.save.config.showother = false
     else
      me.save.config.showother = true
    end
    end
    me.dewdrop:AddLine('text',me.L["showweapon"],'func',info.func,'checked',info.checked,'tooltipFunc',function() return end)
    me.dewdrop:AddLine()
    info.func = function()
     me.save.cds = {}
     for k,v in pairs(me.saveallchars) do
      if v.faction==UnitFactionGroup("player") then me.saveallchars[k]["cds"]={} end
     end 
     me.secureframe:Hide()
     GameTooltip:Hide()
     me.dewdrop:Close(1)
    end
    me.dewdrop:AddLine('text',me.L["resetcds"],'func',info.func,'tooltipFunc',function() return end)
    info.func = function()
     me.moveable = true
     me.secureframe:Hide()
     GameTooltip:Hide()
     me.dewdrop:Close(1)
    end
    me.dewdrop:AddLine('text',me.L["unlock"],'func',info.func,'tooltipFunc',function() return end)   
   --list other chars
   elseif value == "tradelinks" then
    for k,v in me:pairsByKeys(me.saveallchars) do
     if k~=UnitName("player") and v.faction==UnitFactionGroup("player") and v.tradelinks~=nil and me:tcount(v.tradelinks)>0  then
      me.dewdrop:AddLine('hasArrow',true,'text',k,'value',k,'tooltipFunc',function() return end)
     end
    end
   end
  --<<LEVEL 3>>--
  elseif level == 3 then
   --default professions
   if value == "default" then
    me.dewdrop:AddLine('hasArrow',true,'text',me.L["leftclick"],'value',"left",'tooltipFunc',function() return end)
    me.dewdrop:AddLine('hasArrow',true,'text',me.L["shiftleftclick"],'value',"shiftleft",'tooltipFunc',function() return end)
    me.dewdrop:AddLine('hasArrow',true,'text',me.L["altleftclick"],'value',"altleft",'tooltipFunc',function() return end)
    me.dewdrop:AddLine('hasArrow',true,'text',me.L["ctrlleftclick"],'value',"ctrlleft",'tooltipFunc',function() return end)
   --quicklauncher
   elseif value == "launcher" then
    me.dewdrop:AddLine('hasArrow',true,'text',me.L["new"],'value',"newlauncher",'tooltipFunc',function() return end)
    me.dewdrop:AddLine('hasArrow',true,'text',me.L["delete"],'value',"deletelauncher",'tooltipFunc',function() return end)
   --list trades from an other char
   else
    for k,v in me:pairsByKeys(me.saveallchars[value]["tradelinks"]) do
     info.func = function()
      if IsShiftKeyDown() then
       if (not ChatEdit_InsertLink(v) ) then
        ChatFrame1EditBox:Show();
        ChatEdit_InsertLink(v);
       end
      else
       print("|cff00ff00Broker_ProfessionsMenu: "..value..": |r"..v)
      end
     end
     info.tooltipFunc = function()
      local skill,maxskill = strmatch(v,"|Htrade:%d+:(%d+):(%d+):")
      GameTooltip:SetOwner(this, "ANCHOR_NONE")
      GameTooltip:SetPoint("BOTTOMRIGHT",this,"TOPLEFT")
      GameTooltip:ClearLines()
      GameTooltip:AddLine(value,0,1,0)
      GameTooltip:AddDoubleLine(k,skill.."/"..maxskill,1,1,0,0,1,0)
      GameTooltip:AddLine(" ")
      GameTooltip:AddLine(me.L["leftclick_tradelink"])
      GameTooltip:AddLine(me.L["shiftleftclick_tradelink"])
     end
     me.dewdrop:AddLine('text',k,'func',info.func,'tooltipFunc',info.tooltipFunc)
    end
    me.dewdrop:AddLine()
    info.tooltipFunc = function()
     GameTooltip:SetOwner(this, "ANCHOR_NONE")
     GameTooltip:SetPoint("BOTTOMRIGHT",this,"TOPLEFT")
     GameTooltip:ClearLines()
     GameTooltip:AddLine(me.L["deletechartooltip"])
    end
    me.dewdrop:AddLine('text',me.L["delete"],'func',function() me.saveallchars[value]=nil end,'tooltipFunc',info.tooltipFunc,'closeWhenClicked',true)
   end
  --<<LEVEL 4>>--
  elseif level == 4 then
   --New Launcher
   if value == "newlauncher" then	
    for k,v in me:pairsByKeys(me:FilterProfs(me.P.Primary)) do
     if not me.launcher[k] then
      me.dewdrop:AddLine('text',k,'func',function() me.save.launcher[k]=v.icon; me.launcher[k]=me:newlauncher(k,v.icon) end,'disabled',v.disabled,'tooltipFunc',function() return end)
     end
     if (v["more"]~=nil) then
      for kk,vv in me:pairsByKeys(v["more"]) do
       if not vv.disabled and not me.launcher[kk] then
        me.dewdrop:AddLine('text',"->"..kk,'func',function() me.save.launcher[kk]=vv.icon; me.launcher[kk]=me:newlauncher(kk,vv.icon) end,'tooltipFunc',function() return end)
       end
      end
     end
    end
    me.dewdrop:AddLine()
    for k,v in me:pairsByKeys(me:FilterProfs(me.P.Secondary)) do
     if not me.launcher[k] then
      me.dewdrop:AddLine('text',k,'func',function() me.save.launcher[k]=v.icon; me.launcher[k]=me:newlauncher(k,v.icon) end,'disabled',v.disabled,'tooltipFunc',function() return end)
     end
     if (v["more"]~=nil) then
      for kk,vv in me:pairsByKeys(v["more"]) do
       if not vv.disabled and not me.launcher[kk] then
        me.dewdrop:AddLine('text',"->"..kk,'func',function() me.save.launcher[kk]=vv.icon; me.launcher[kk]=me:newlauncher(kk,vv.icon) end,'tooltipFunc',function() return end)
       end
      end
     end
    end
   --Delete Launcher
   elseif value == "deletelauncher" then
    for k,v in pairs(me.save.launcher) do
     me.dewdrop:AddLine('text',k,'func',function() me.save.launcher[k]=nil; me:Error(me.L["relog"]) end,'tooltipFunc',function() return end)
    end	
   --Default Profession Menu
   else
    if (me.save.default[value] == "---") then info.checked = true else info.checked = nil end
    info.func = function()
     me.save.default[value] = "---"
     if value=="left" then
      me.save.default.icon = "Interface\\Icons\\Trade_BlackSmithing"
      me:Professions_UpdateInfo(me.save.default.left,me.save.default.icon)
     end
    end
    me.dewdrop:AddLine('text',"---",'func',info.func,'checked',info.checked,'tooltipFunc',function() return end)	
    me.dewdrop:AddLine()		
    for k,v in me:pairsByKeys(me:FilterProfs(me.P.Primary)) do
     if (me.save.default[value] == k) then info.checked = true else info.checked = nil end
     info.func = function()
      me.save.default[value] = k
      if value=="left" then
       me.save.default.icon = v.icon
       me:Professions_UpdateInfo(me.save.default.left,me.save.default.icon)
      end
     end
     me.dewdrop:AddLine('text',k,'func',info.func,'checked',info.checked,'disabled',v.disabled,'tooltipFunc',function() return end)
     if (v["more"]~=nil) then
      for kk,vv in me:pairsByKeys(v["more"]) do
       if (me.save.default[value] == kk) then info.checked = true else info.checked = nil end
       info.func = function()
        me.save.default[value] = kk
        if value=="left" then
         me.save.default.icon = vv.icon
         me:Professions_UpdateInfo(me.save.default.left,me.save.default.icon)
        end
       end
       if (vv.disabled == nil) then me.dewdrop:AddLine('text',"->"..kk,'func',info.func,'checked',info.checked,'tooltipFunc',function() return end) end
      end
     end
    end
    me.dewdrop:AddLine()
    for k,v in me:pairsByKeys(me:FilterProfs(me.P.Secondary)) do
     if (me.save.default[value] == k) then info.checked = true else info.checked = nil end
     info.func = function()
      me.save.default[value] = k
      if value=="left" then
       me.save.default.icon = v.icon
       me:Professions_UpdateInfo(me.save.default.left,me.save.default.icon)
      end
     end
     me.dewdrop:AddLine('text',k,'func',info.func,'checked',info.checked,'disabled',v.disabled,'tooltipFunc',function() return end)
     if (v["more"]~=nil) then
      for kk,vv in me:pairsByKeys(v["more"]) do
       if (me.save.default[value] == kk) then info.checked = true else info.checked = nil end
       info.func = function()
        me.save.default[value] = kk
        if value=="left" then
         me.save.default.icon = vv.icon
         me:Professions_UpdateInfo(me.save.default.left,me.save.default.icon)
        end
       end
       if (vv.disabled == nil) then me.dewdrop:AddLine('text',"->"..kk,'func',info.func,'checked',info.checked,'tooltipFunc',function() return end) end
      end
     end
    end
   end --else
  end
  --<<END LEVEL>>--
end --function()